;#___________________________________________________________________________________________________
;****************************************************************************************************|
; Get Param (c) Sergei Steshin (Akyltist)                                                            |
;----------------------------------------------------------------------------------------------------|
;; Charset:DOS-866 Font:Consolas Size:8pt                                                            |
;.....................................................................................................
;; compiler:     FASM 1.69.31                                                                        |
;; version:      0.3.0                                                                               |
;; last update:  13/09/2013                                                                          |
;; e-mail:       dr.steshin@gmail.com                                                                |
;.....................................................................................................
;; History:                                                                                          |
;; 0.1.0 - ࢠ  .                                                                     |
;.....................................................................................................
;; All rights reserved.                                                                              |
;;                                                                                                   |
;; Redistribution and use in source and binary forms, with or without modification, are permitted    |
;; provided that the following conditions are met:                                                   |
;;       * Redistributions of source code must retain the above copyright notice, this list of       |
;;         conditions and the following disclaimer.                                                  |
;;       * Redistributions in binary form must reproduce the above copyright notice, this list of    |
;;         conditions and the following disclaimer in the documentation and/or other materials       |
;;         provided with the distribution.                                                           |
;;       * Neither the name of the <organization> nor the names of its contributors may be used to   |
;;         endorse or promote products derived from this software without specific prior written     |
;;         permission.                                                                               |
;;                                                                                                   |
;; THIS SOFTWARE IS PROVIDED BY Sergei Steshin ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,      |
;; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A        |
;; PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY DIRECT, |
;; INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED    |
;; TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS       |
;; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT          |
;; LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS  |
;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                      |
;....................................................................................................|



    GP_BUFF_SIZE equ 64     ; ᨬ쭠  頥 ࠬ () 64*4 (dd) = 256 



__get_param_count:
;-----------------------------------------------------------------------------;
; । ⢮ । ࠬ஢                                 ;
;-----------------------------------------------------------------------------;
; INP : ESI -> [RU] ப  ࠬࠬ   ->  [EN] path                      ;
; OUT : EAX -> [RU] ⢮ ࠬ஢  ->  [EN] get count                 ;
;-----------------------------------------------------------------------------;
; DESTROYS REGISTERS: EAX                                                     ;
;-----------------------------------------------------------------------------;
    pusha

    mov     edi,esi
    cld
    xor     al, al
    mov     ecx, 0FFFFFFFFh
    mov     esi, edi
    repne   scasb
    sub     edi, esi
    mov     eax, edi
    dec     eax                 ; get path length

    cmp     eax,0               ; length = 0
    je      loc_gpc_end         ; goto exit

    mov     ebp, eax            ; (l) set length
    xor     eax, eax
    mov     [_c], eax           ; set local counter
    xor     ecx, ecx            ; (i) set loop
    xor     ebx, ebx            ; (k) set "
    xor     edi, edi            ; (w) set word

 loc_10033:
    mov     eax, ecx
    mov     al, byte [esi+eax]
    cmp     al, 20h ; ' '
    jz      loc_1007D
    mov     edx, ecx
    cmp     al, 22h ; '"'
    jnz     loc_10065
    cmp     ebx, 0
    jnz     loc_1005E
    mov     ebx, 1
    jmp     loc_10065
 loc_1005E:
    xor     ebx, ebx
 loc_10065:
    cmp     edi, 0
    jnz     loc_10096
    inc     [_c]
    mov     edi, 1
    jmp     loc_10096

 loc_1007D:
    cmp     ebx, 0
    jnz     loc_10096
    cmp     edi, 1
    jnz     loc_10096
    xor     edi, edi

 loc_10096:
    inc     ecx
    mov     eax, ecx
    cmp     eax, ebp
    jnz     loc_10033
 loc_gpc_end:

    popa
    mov     eax, [_c]
    retn


__get_param_str:
;-----------------------------------------------------------------------------;
; 頥 ࠬ  浪                                    ;
;-----------------------------------------------------------------------------;
; INP : ESI -> [RU] ப  ࠬࠬ         ->  [EN] path                ;
; INP : EAX -> [RU] 浪  ࠬ   ->  [EN] paramstr(eax)       ;
; OUT : EAX -> [RU]  ࠬ  ᨬ   ->  [EN] length              ;
; OUT : EDX -> [RU] 㪠⥫  ࠬ        ->  [EN] params              ;
;-----------------------------------------------------------------------------;
; DESTROYS REGISTERS: EAX                                                     ;
;-----------------------------------------------------------------------------;
    pusha

    push    eax                 ; GetParamStr(EAX) -> write in _b

    xor     ecx, ecx
 loc_10009:
    mov     byte [_gp_buffer+ecx],0
    inc     ecx
    cmp     ecx, 0FFh
    jl      loc_10009

    mov     edi,esi
    cld
    xor     al, al
    mov     ecx, 0FFFFFFFFh
    mov     esi, edi
    repne   scasb
    sub     edi, esi
    mov     eax, edi
    dec     eax                 ; get path length

    cmp     eax,0               ; length = 0
    je      loc_gps_end         ; goto exit

    mov     ebp, eax            ; (l) set length
    pop     eax
    mov     [_c], eax           ; set local counter
    xor     eax, eax
    mov     [_z], eax
    xor     ecx, ecx            ; (i) set loop
    mov     [_j], eax
    xor     ebx, ebx
    xor     edi, edi            ; (w) set word


 loc_10044:
    mov     eax, ecx
    mov     al, byte [esi+eax]
    cmp     al, 20h ; ' '
    jz      loc_100B4
    cmp     edi, 0
    jnz     loc_10069
    inc     [_z]
    mov     edi, 1
 loc_10069:
    mov     edx, [_z]
    cmp     edx, [_c]
    jnz     loc_1008F
    ;mov     edx, ecx
    mov     edx, [_j]
    mov     byte [_gp_buffer+edx], al
    inc     [_j]
 loc_1008F:
    mov     edx, ecx
    cmp     al, 22h ; '"'
    jnz     loc_100F9
    cmp     ebx, 0
    jnz     loc_100AB
    mov     ebx, 1
    jmp     loc_100F9
 loc_100AB:
    xor     ebx, ebx
    jmp     loc_100F9
 loc_100B4:
    cmp     ebx, 1
    jnz     loc_100E5
    mov     edx, [_z]
    cmp     edx, [_c]
    jnz     loc_100F9
    ;mov     edx, ecx
    mov     edx, [_j]
    mov     byte [_gp_buffer+edx], al
    inc     [_j]
    jmp     loc_100F9
 loc_100E5:
    xor     edi, edi
    mov     eax, [_z]
    cmp     eax, [_c]
    jz      loc_10110
 loc_100F9:
    inc     ecx
    mov     eax, ecx
    cmp     eax, ebp
    jle     loc_10044
 loc_10110:
    popa
    mov     eax, [_j]
    mov     edx,_gp_buffer
    retn
 loc_gps_end:
    pop     eax
    xor     eax,eax
    mov     edx,_gp_buffer
    popa
    retn

;---------------------------------------------------------------
_gp_buffer  dd GP_BUFF_SIZE  dup(0)           ; buffer string
_c              dd 0                    ; params count
_z              dd 0                    ; current count
_j              dd 0                    ; loop in buffer



